#ifndef OGLWDGT_H
#define OGLWDGT_H

#include <QGLWidget>
#include <QMessageBox>
#include <QLCDNumber>
#include "_nglew.h"
#include "_nocl.h"

class OGLWdgt : public QGLWidget
{
Q_OBJECT
protected:
    virtual void initializeGL();
    virtual void resizeGL(int nWidth,int nHeight);
    virtual void paintGL();
    virtual void mousePressEvent(QMouseEvent *qme);
    virtual void mouseMoveEvent(QMouseEvent *qme);
    virtual void wheelEvent(QWheelEvent * qwe);
public:
    explicit OGLWdgt(QWidget *parent = 0);

    void GenInit();
    void RunKernel();
    cl_int Cleanup(cl_int iErr);

    float fxRot;
    float fyRot;
    float fzRot;
    float fzTr;
    float fx;

    float fanim;
    float fanimspeed;
    float ffreq;
    
    _glewFun glewFun;
    _noclInf noclInf;
    int uiCurPlat;
    int uiCurDev;
    int iCountSec;
    
    int nWidth;
    int nHeight;
    
    QPoint qpoint;

    char cErr[256];
    cl_int iErr;

    bool brun;
    unsigned int mesh_width;
    unsigned int mesh_height;

    cl_context clc;
    cl_program clp;
    cl_kernel clk;
    cl_mem vbo_cl;
    cl_command_queue clcq;
    GLuint vbo;

    QLCDNumber *qlsd;

signals:

public slots:
    void draw(float fxx);
    void animate();
    void framecount();

};

#endif // OGLWDGT_H
