#ifndef _NGLEW_H
#define _NGLEW_H

#define WINGDIAPI

#include <CL/opencl.h>
#include <GL/gl.h>
#include <GL/glext.h>
#include <GL/glu.h>
#include <QtOpenGL>

typedef ptrdiff_t GLsizeiptr;
typedef char GLchar;

#define GL_ARRAY_BUFFER 0x8892
#define GL_WRITE_ONLY_ARB 0x88B9
#define GL_WRITE_ONLY 0x88B9
#define GL_DYNAMIC_DRAW 0x88E8
#define GL_STREAM_DRAW 0x88E0
#define GL_PIXEL_PACK_BUFFER 0x88EB
#define GL_READ_ONLY 0x88B8
#define GL_PIXEL_UNPACK_BUFFER 0x88EC
#define GL_FRAGMENT_SHADER 0x8B30
#define GL_VERTEX_SHADER 0x8B31
#define GL_VERTEX_PROGRAM_POINT_SIZE 0x8642


#ifndef Q_WS_MAC
# ifndef APIENTRYP
#   ifdef APIENTRY
#     define APIENTRYP APIENTRY *
#   else
#     define APIENTRY
#     define APIENTRYP *
#   endif
# endif
#else
# define APIENTRY
# define APIENTRYP *
#endif

typedef GLenum (APIENTRY *_glewInit) ();
typedef void (APIENTRY *_glGenBuffers) (GLsizei, GLuint *);
typedef void (APIENTRY *_glBindBuffer) (GLenum target, GLuint buffer);
typedef GLboolean (APIENTRY *_glewIsSupported) (const char* name);
typedef void (APIENTRY *_glBufferData) (GLenum target, GLsizeiptr size, const GLvoid* data, GLenum usage);
typedef void (APIENTRY *_glDeleteBuffers) (GLsizei n, const GLuint* buffers);
typedef void (APIENTRY *_glBindBufferARB) (GLenum target, GLuint buffer);
typedef GLvoid * (APIENTRY *_glMapBufferARB) (GLenum target, GLenum access);
typedef GLvoid * (APIENTRY *_glMapBuffer) (GLenum target, GLenum access);
typedef GLboolean (APIENTRY *_glUnmapBufferARB) (GLenum target);
typedef GLboolean (APIENTRY *_glUnmapBuffer) (GLenum target);
typedef void (APIENTRY *_glGetBufferParameteriv) (GLenum target, GLenum pname, GLint* params);
typedef GLuint (APIENTRY * _glCreateShader) (GLenum type);
typedef void (APIENTRY * _glShaderSource) (GLuint shader, GLsizei count, const GLchar** strings, const GLint* lengths);;
typedef void (APIENTRY * _glCompileShader) (GLuint shader);
typedef GLuint (APIENTRY * _glCreateProgram) (void);
typedef void (APIENTRY * _glAttachShader) (GLuint program, GLuint shader);
typedef void (APIENTRY * _glLinkProgram) (GLuint program);
typedef void (APIENTRY * _glUseProgram) (GLuint program);

typedef struct __glewFun
{
    _glUseProgram UseProgram;
    _glLinkProgram LinkProgram;
    _glAttachShader AttachShader;
    _glCreateProgram CreateProgram;
    _glCompileShader CompileShader;
    _glShaderSource ShaderSource;
    _glCreateShader CreateShader;
    _glGenBuffers GenBuffers;
    _glBindBuffer BindBuffer;
    _glBufferData BufferData;
    _glBindBufferARB BindBufferARB;
    _glMapBufferARB MapBufferARB;
    _glMapBuffer MapBuffer;
    _glUnmapBufferARB UnmapBufferARB;
    _glUnmapBuffer UnmapBuffer;
    _glDeleteBuffers DeleteBuffers;
    _glewInit Init;
    _glewIsSupported IsSupported;
    _glGetBufferParameteriv GetBufferParameteriv;
} _glewFun;

void LoadFun(_glewFun *glewFun,QGLWidget *widget);
void GetGLExt();



#endif // _NGLEW_H
