#include "_nocl.h"

cl_int _noclGetInfo(_noclInf *noclInf)
{
    if (noclInf->noclPlt)
    {
        for (unsigned int i=0;i<noclInf->uiNumP;i++)
        {
            for (unsigned  int j=0;j<noclInf->noclPlt[i].uiNumD;j++)
            {
               if (noclInf->noclPlt[i].noclDev[j].max_work_item_sizes) free(noclInf->noclPlt[i].noclDev[j].max_work_item_sizes);
               if (noclInf->noclPlt[i].noclDev[j].imgFormats) free(noclInf->noclPlt[i].noclDev[j].imgFormats);
               if (noclInf->noclPlt[i].noclDev[j].imgFormats3D) free(noclInf->noclPlt[i].noclDev[j].imgFormats3D);
            }
            if (noclInf->noclPlt[i].noclDev) free(noclInf->noclPlt[i].noclDev);
            if (noclInf->noclPlt[i].cldi) free(noclInf->noclPlt[i].cldi);
        }
        free(noclInf->noclPlt);
        free(noclInf->clpi);
    }

    cl_int ciErrNum=CL_SUCCESS;
    unsigned long i=0;
    unsigned long j=0;
    cl_context context;

    ciErrNum=clGetPlatformIDs(0,NULL,&noclInf->uiNumP);
    if ((ciErrNum!=CL_SUCCESS) || (noclInf->uiNumP<1)) return CL_DEVICE_NOT_FOUND;

    if ((noclInf->noclPlt=(_noclPlt *)malloc(sizeof(_noclPlt)*noclInf->uiNumP))==NULL) return CL_MEM_OBJECT_ALLOCATION_FAILURE;
    if ((noclInf->clpi=(cl_platform_id *)malloc(sizeof(cl_platform_id)*noclInf->uiNumP))==NULL) return CL_MEM_OBJECT_ALLOCATION_FAILURE;

    _nERRSUC(clGetPlatformIDs(noclInf->uiNumP,noclInf->clpi,&noclInf->uiNumP))

    for (i=1;i<=noclInf->uiNumP;i++)
    {
        _nERRSUC(clGetPlatformInfo(noclInf->clpi[i-1],CL_PLATFORM_PROFILE,sizeof(noclInf->noclPlt[i-1].Profile),noclInf->noclPlt[i-1].Profile, NULL))
        _nERRSUC(clGetPlatformInfo(noclInf->clpi[i-1],CL_PLATFORM_EXTENSIONS,sizeof(noclInf->noclPlt[i-1].Ext),noclInf->noclPlt[i-1].Ext, NULL))
        _nERRSUC(clGetPlatformInfo(noclInf->clpi[i-1],CL_PLATFORM_NAME,sizeof(noclInf->noclPlt[i-1].Name),noclInf->noclPlt[i-1].Name, NULL))
        _nERRSUC(clGetPlatformInfo(noclInf->clpi[i-1],CL_PLATFORM_VENDOR,sizeof(noclInf->noclPlt[i-1].Vendor),noclInf->noclPlt[i-1].Vendor, NULL))
        _nERRSUC(clGetPlatformInfo(noclInf->clpi[i-1],CL_PLATFORM_VERSION,sizeof(noclInf->noclPlt[i-1].Ver),noclInf->noclPlt[i-1].Ver, NULL))

        _nERRSUC(clGetDeviceIDs(noclInf->clpi[i-1],CL_DEVICE_TYPE_ALL,0,NULL,&noclInf->noclPlt[i-1].uiNumD))

        if (noclInf->noclPlt[i-1].uiNumD<1) return CL_DEVICE_NOT_FOUND;

        if ((noclInf->noclPlt[i-1].noclDev=(_noclDev *)malloc(sizeof(_noclDev)*noclInf->noclPlt[i-1].uiNumD))==NULL) return CL_MEM_OBJECT_ALLOCATION_FAILURE;
        memset(noclInf->noclPlt[i-1].noclDev,0,sizeof(_noclDev)*noclInf->noclPlt[i-1].uiNumD);
        if ((noclInf->noclPlt[i-1].cldi=(cl_device_id *)malloc(sizeof(cl_device_id)*noclInf->noclPlt[i-1].uiNumD))==NULL) return CL_MEM_OBJECT_ALLOCATION_FAILURE;

        _nERRSUC(clGetDeviceIDs(noclInf->clpi[i-1],CL_DEVICE_TYPE_ALL,noclInf->noclPlt[i-1].uiNumD,noclInf->noclPlt[i-1].cldi,&noclInf->noclPlt[i-1].uiNumD))

        for (j=0;j<noclInf->noclPlt[i-1].uiNumD;j++)
        {
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_NAME,sizeof(noclInf->noclPlt[i-1].noclDev[j].Name), &noclInf->noclPlt[i-1].noclDev[j].Name, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_VERSION,sizeof(noclInf->noclPlt[i-1].noclDev[j].Ver), &noclInf->noclPlt[i-1].noclDev[j].Ver, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_VENDOR,sizeof(noclInf->noclPlt[i-1].noclDev[j].Vendor), &noclInf->noclPlt[i-1].noclDev[j].Vendor, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PROFILE,sizeof(noclInf->noclPlt[i-1].noclDev[j].Profile), &noclInf->noclPlt[i-1].noclDev[j].Profile, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_EXTENSIONS,sizeof(noclInf->noclPlt[i-1].noclDev[j].Ext), &noclInf->noclPlt[i-1].noclDev[j].Ext, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PLATFORM,sizeof(noclInf->noclPlt[i-1].noclDev[j].Platform), &noclInf->noclPlt[i-1].noclDev[j].Platform, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_TYPE,sizeof(noclInf->noclPlt[i-1].noclDev[j].type), &noclInf->noclPlt[i-1].noclDev[j].type, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_VENDOR_ID,sizeof(noclInf->noclPlt[i-1].noclDev[j].vendor_id), &noclInf->noclPlt[i-1].noclDev[j].vendor_id, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_COMPUTE_UNITS,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_compute_units), &noclInf->noclPlt[i-1].noclDev[j].max_compute_units, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_work_item_dimensions), &noclInf->noclPlt[i-1].noclDev[j].max_work_item_dimensions, NULL))

            if ((noclInf->noclPlt[i-1].noclDev[j].max_work_item_sizes=(size_t *)malloc(sizeof(size_t)*noclInf->noclPlt[i-1].noclDev[j].max_work_item_dimensions))==NULL) return CL_MEM_OBJECT_ALLOCATION_FAILURE;
            memset(noclInf->noclPlt[i-1].noclDev[j].max_work_item_sizes,0,sizeof(size_t)*noclInf->noclPlt[i-1].noclDev[j].max_work_item_dimensions);
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_WORK_ITEM_SIZES,sizeof(size_t)*noclInf->noclPlt[i-1].noclDev[j].max_work_item_dimensions, noclInf->noclPlt[i-1].noclDev[j].max_work_item_sizes, NULL));

            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_WORK_GROUP_SIZE,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_work_group_size), &noclInf->noclPlt[i-1].noclDev[j].max_work_group_size, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PREFERRED_VECTOR_WIDTH_CHAR,sizeof(noclInf->noclPlt[i-1].noclDev[j].vector_width_char), &noclInf->noclPlt[i-1].noclDev[j].vector_width_char, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PREFERRED_VECTOR_WIDTH_DOUBLE,sizeof(noclInf->noclPlt[i-1].noclDev[j].vector_width_double), &noclInf->noclPlt[i-1].noclDev[j].vector_width_double, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PREFERRED_VECTOR_WIDTH_FLOAT,sizeof(noclInf->noclPlt[i-1].noclDev[j].vector_width_float), &noclInf->noclPlt[i-1].noclDev[j].vector_width_float, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PREFERRED_VECTOR_WIDTH_INT,sizeof(noclInf->noclPlt[i-1].noclDev[j].vector_width_int), &noclInf->noclPlt[i-1].noclDev[j].vector_width_int, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PREFERRED_VECTOR_WIDTH_LONG,sizeof(noclInf->noclPlt[i-1].noclDev[j].vector_width_long), &noclInf->noclPlt[i-1].noclDev[j].vector_width_long, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_PREFERRED_VECTOR_WIDTH_SHORT,sizeof(noclInf->noclPlt[i-1].noclDev[j].vector_width_short), &noclInf->noclPlt[i-1].noclDev[j].vector_width_short, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_CLOCK_FREQUENCY ,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_clock_frequency), &noclInf->noclPlt[i-1].noclDev[j].max_clock_frequency, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_ADDRESS_BITS,sizeof(noclInf->noclPlt[i-1].noclDev[j].address_bits), &noclInf->noclPlt[i-1].noclDev[j].address_bits, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_READ_IMAGE_ARGS,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_read_image_args), &noclInf->noclPlt[i-1].noclDev[j].max_read_image_args, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_WRITE_IMAGE_ARGS,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_write_image_args), &noclInf->noclPlt[i-1].noclDev[j].max_write_image_args, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_MEM_ALLOC_SIZE,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_mem_alloc_size), &noclInf->noclPlt[i-1].noclDev[j].max_mem_alloc_size, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_GLOBAL_MEM_SIZE,sizeof(noclInf->noclPlt[i-1].noclDev[j].global_mem_size), &noclInf->noclPlt[i-1].noclDev[j].global_mem_size, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_ERROR_CORRECTION_SUPPORT,sizeof(noclInf->noclPlt[i-1].noclDev[j].error_correction_support), &noclInf->noclPlt[i-1].noclDev[j].error_correction_support, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_LOCAL_MEM_TYPE,sizeof(noclInf->noclPlt[i-1].noclDev[j].local_mem_type), &noclInf->noclPlt[i-1].noclDev[j].local_mem_type, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_LOCAL_MEM_SIZE,sizeof(noclInf->noclPlt[i-1].noclDev[j].local_mem_size), &noclInf->noclPlt[i-1].noclDev[j].local_mem_size, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_MAX_CONSTANT_BUFFER_SIZE,sizeof(noclInf->noclPlt[i-1].noclDev[j].max_constant_buffer_size), &noclInf->noclPlt[i-1].noclDev[j].max_constant_buffer_size, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_QUEUE_PROPERTIES,sizeof(noclInf->noclPlt[i-1].noclDev[j].queue_properties), &noclInf->noclPlt[i-1].noclDev[j].queue_properties, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_IMAGE_SUPPORT,sizeof(noclInf->noclPlt[i-1].noclDev[j].image_support), &noclInf->noclPlt[i-1].noclDev[j].image_support, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_SINGLE_FP_CONFIG,sizeof(noclInf->noclPlt[i-1].noclDev[j].single_fp_config), &noclInf->noclPlt[i-1].noclDev[j].single_fp_config, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_IMAGE2D_MAX_WIDTH,sizeof(noclInf->noclPlt[i-1].noclDev[j].image2d_max_width), &noclInf->noclPlt[i-1].noclDev[j].image2d_max_width, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_IMAGE2D_MAX_HEIGHT,sizeof(noclInf->noclPlt[i-1].noclDev[j].image2d_max_height), &noclInf->noclPlt[i-1].noclDev[j].image2d_max_height, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_IMAGE3D_MAX_WIDTH,sizeof(noclInf->noclPlt[i-1].noclDev[j].image3d_max_width), &noclInf->noclPlt[i-1].noclDev[j].image3d_max_width, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_IMAGE3D_MAX_HEIGHT,sizeof(noclInf->noclPlt[i-1].noclDev[j].image3d_max_height), &noclInf->noclPlt[i-1].noclDev[j].image3d_max_height, NULL))
            _nERRSUC(clGetDeviceInfo(noclInf->noclPlt[i-1].cldi[j],CL_DEVICE_IMAGE3D_MAX_DEPTH,sizeof(noclInf->noclPlt[i-1].noclDev[j].image3d_max_depth), &noclInf->noclPlt[i-1].noclDev[j].image3d_max_depth, NULL))

            context=clCreateContext(0,1,&noclInf->noclPlt[i-1].cldi[j],NULL,NULL,&ciErrNum);
            _nERRSUC(clGetSupportedImageFormats(context,CL_MEM_READ_ONLY,CL_MEM_OBJECT_IMAGE2D,NULL, NULL,&noclInf->noclPlt[i-1].noclDev[j].uiSup2D));
            noclInf->noclPlt[i-1].noclDev[j].imgFormats=new cl_image_format[noclInf->noclPlt[i-1].noclDev[j].uiSup2D];
            clGetSupportedImageFormats(context, CL_MEM_READ_ONLY,CL_MEM_OBJECT_IMAGE2D,noclInf->noclPlt[i-1].noclDev[j].uiSup2D, noclInf->noclPlt[i-1].noclDev[j].imgFormats, NULL);

            _nERRSUC(clGetSupportedImageFormats(context,CL_MEM_READ_ONLY,CL_MEM_OBJECT_IMAGE3D,NULL, NULL,&noclInf->noclPlt[i-1].noclDev[j].uiSup3D));
            noclInf->noclPlt[i-1].noclDev[j].imgFormats3D=new cl_image_format[noclInf->noclPlt[i-1].noclDev[j].uiSup3D];
            clGetSupportedImageFormats(context, CL_MEM_READ_ONLY,CL_MEM_OBJECT_IMAGE3D,noclInf->noclPlt[i-1].noclDev[j].uiSup3D, noclInf->noclPlt[i-1].noclDev[j].imgFormats3D, NULL);
        }
    }
    return ciErrNum;
}

void _noclGetNameErr(cl_int iErr,char *cErr)
{
    if (iErr==CL_SUCCESS) strcpy(cErr,"CL_SUCCESS\0");
    if (iErr==CL_DEVICE_NOT_FOUND) strcpy(cErr,"CL_DEVICE_NOT_FOUND\0");
    if (iErr==CL_DEVICE_NOT_AVAILABLE) strcpy(cErr,"CL_DEVICE_NOT_AVAILABLE\0");
    if (iErr==CL_COMPILER_NOT_AVAILABLE) strcpy(cErr,"CL_COMPILER_NOT_AVAILABLE\0");
    if (iErr==CL_MEM_OBJECT_ALLOCATION_FAILURE) strcpy(cErr,"CL_MEM_OBJECT_ALLOCATION_FAILURE\0");
    if (iErr==CL_OUT_OF_RESOURCES) strcpy(cErr,"CL_OUT_OF_RESOURCES\0");
    if (iErr==CL_OUT_OF_HOST_MEMORY) strcpy(cErr,"CL_OUT_OF_HOST_MEMORY\0");
    if (iErr==CL_PROFILING_INFO_NOT_AVAILABLE) strcpy(cErr,"CL_PROFILING_INFO_NOT_AVAILABLE\0");
    if (iErr==CL_MEM_COPY_OVERLAP) strcpy(cErr,"CL_MEM_COPY_OVERLAP\0");
    if (iErr==CL_IMAGE_FORMAT_MISMATCH) strcpy(cErr,"CL_IMAGE_FORMAT_MISMATCH\0");
    if (iErr==CL_IMAGE_FORMAT_NOT_SUPPORTED) strcpy(cErr,"CL_IMAGE_FORMAT_NOT_SUPPORTED\0");
    if (iErr==CL_BUILD_PROGRAM_FAILURE) strcpy(cErr,"CL_BUILD_PROGRAM_FAILURE\0");
    if (iErr==CL_MAP_FAILURE) strcpy(cErr,"CL_MAP_FAILURE\0");
    if (iErr==CL_INVALID_VALUE) strcpy(cErr,"CL_INVALID_VALUE\0");
    if (iErr==CL_INVALID_DEVICE_TYPE) strcpy(cErr,"CL_INVALID_DEVICE_TYPE\0");
    if (iErr==CL_INVALID_PLATFORM) strcpy(cErr,"CL_INVALID_PLATFORM\0");
    if (iErr==CL_INVALID_DEVICE) strcpy(cErr,"CL_INVALID_DEVICE\0");
    if (iErr==CL_INVALID_CONTEXT) strcpy(cErr,"CL_INVALID_CONTEXT\0");
    if (iErr==CL_INVALID_QUEUE_PROPERTIES) strcpy(cErr,"CL_INVALID_QUEUE_PROPERTIES\0");
    if (iErr==CL_INVALID_COMMAND_QUEUE) strcpy(cErr,"CL_INVALID_COMMAND_QUEUE\0");
    if (iErr==CL_INVALID_HOST_PTR) strcpy(cErr,"CL_INVALID_HOST_PTR\0");
    if (iErr==CL_INVALID_MEM_OBJECT) strcpy(cErr,"CL_INVALID_MEM_OBJECT\0");
    if (iErr==CL_INVALID_IMAGE_FORMAT_DESCRIPTOR) strcpy(cErr,"CL_INVALID_IMAGE_FORMAT_DESCRIPTOR\0");
    if (iErr==CL_INVALID_IMAGE_SIZE) strcpy(cErr,"CL_INVALID_IMAGE_SIZE\0");
    if (iErr==CL_INVALID_SAMPLER) strcpy(cErr,"CL_INVALID_SAMPLER\0");
    if (iErr==CL_INVALID_BINARY) strcpy(cErr,"CL_INVALID_BINARY\0");
    if (iErr==CL_INVALID_BUILD_OPTIONS) strcpy(cErr,"CL_INVALID_BUILD_OPTIONS\0");
    if (iErr==CL_INVALID_PROGRAM) strcpy(cErr,"CL_INVALID_PROGRAM\0");
    if (iErr==CL_INVALID_PROGRAM_EXECUTABLE) strcpy(cErr,"CL_INVALID_PROGRAM_EXECUTABLE\0");
    if (iErr==CL_INVALID_KERNEL_NAME) strcpy(cErr,"CL_INVALID_KERNEL_NAME\0");
    if (iErr==CL_INVALID_KERNEL_DEFINITION) strcpy(cErr,"CL_INVALID_KERNEL_DEFINITION\0");
    if (iErr==CL_INVALID_KERNEL) strcpy(cErr,"CL_INVALID_KERNEL\0");
    if (iErr==CL_INVALID_ARG_INDEX) strcpy(cErr,"CL_INVALID_ARG_INDEX\0");
    if (iErr==CL_INVALID_ARG_VALUE) strcpy(cErr,"CL_INVALID_ARG_VALUE\0");
    if (iErr==CL_INVALID_ARG_SIZE) strcpy(cErr,"CL_INVALID_ARG_SIZE\0");
    if (iErr==CL_INVALID_KERNEL_ARGS) strcpy(cErr,"CL_INVALID_KERNEL_ARGS\0");
    if (iErr==CL_INVALID_WORK_DIMENSION) strcpy(cErr,"CL_INVALID_WORK_DIMENSION\0");
    if (iErr==CL_INVALID_WORK_GROUP_SIZE) strcpy(cErr,"CL_INVALID_WORK_GROUP_SIZE\0");
    if (iErr==CL_INVALID_WORK_ITEM_SIZE) strcpy(cErr,"CL_INVALID_WORK_ITEM_SIZE\0");
    if (iErr==CL_INVALID_GLOBAL_OFFSET) strcpy(cErr,"CL_INVALID_GLOBAL_OFFSET\0");
    if (iErr==CL_INVALID_EVENT_WAIT_LIST) strcpy(cErr,"CL_INVALID_EVENT_WAIT_LIST\0");
    if (iErr==CL_INVALID_EVENT) strcpy(cErr,"CL_INVALID_EVENT\0");
    if (iErr==CL_INVALID_OPERATION) strcpy(cErr,"CL_INVALID_OPERATION\0");
    if (iErr==CL_INVALID_GL_OBJECT) strcpy(cErr,"CL_INVALID_GL_OBJECT\0");
    if (iErr==CL_INVALID_BUFFER_SIZE) strcpy(cErr,"CL_INVALID_BUFFER_SIZE\0");
    if (iErr==CL_INVALID_MIP_LEVEL) strcpy(cErr,"CL_INVALID_MIP_LEVEL\0");
    if (iErr==CL_INVALID_GLOBAL_WORK_SIZE) strcpy(cErr,"CL_INVALID_GLOBAL_WORK_SIZE\0");

    return;
}
