#ifndef _NOCL_H
#define _NOCL_H

#include <CL/opencl.h>
#include <stdlib.h>
#include <string.h>

#define _nERRSUC(_ncerr) if (_ncerr!=CL_SUCCESS) return _ncerr;

typedef struct __noclDev
{
    char Profile[256];
    char Ver[256];
    char Name[256];
    char Vendor[256];
    cl_platform_id Platform;
    char Ext[1024];
    cl_device_type type;
    cl_uint vendor_id;
    cl_uint max_compute_units;
    cl_uint max_work_item_dimensions;
    size_t *max_work_item_sizes;
    size_t max_work_group_size;
    cl_uint vector_width_char;
    cl_uint vector_width_short;
    cl_uint vector_width_int;
    cl_uint vector_width_long;
    cl_uint vector_width_float;
    cl_uint vector_width_double;
    cl_uint max_clock_frequency;
    cl_uint address_bits;
    cl_uint max_read_image_args;
    cl_uint max_write_image_args;
    cl_uint uiSup2D;
    cl_uint uiSup3D;
    cl_ulong max_mem_alloc_size;
    cl_ulong global_mem_size;
    cl_bool error_correction_support;
    cl_device_local_mem_type local_mem_type;
    cl_ulong local_mem_size;
    cl_ulong max_constant_buffer_size;
    cl_command_queue_properties queue_properties;
    cl_bool image_support;
    cl_device_fp_config single_fp_config;
    cl_image_format* imgFormats;
    cl_image_format* imgFormats3D;
    size_t image2d_max_width;
    size_t image2d_max_height;
    size_t image3d_max_width;
    size_t image3d_max_height;
    size_t image3d_max_depth;



} _noclDev;

typedef struct __noclPlt
{
    _noclDev *noclDev;
    cl_device_id *cldi;
    cl_uint uiNumD;

    char Profile[256];
    char Ver[256];
    char Name[256];
    char Vendor[256];
    char Ext[1024];
} _noclPlt;
typedef struct __noclInf
{
    _noclPlt *noclPlt;
    cl_platform_id *clpi;
    cl_uint uiNumP;
} _noclInf;

cl_int _noclGetInfo(_noclInf *noclInf);
void _noclGetNameErr(cl_int iErr, char *cErr);

#endif // _NOCL_H
