#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#define WINGDIAPI

#include "_nglew.h"
#include "_nocl.h"
#include <QMainWindow>
#include <CL/opencl.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include <QDebug>
#include <QtOpenGL>
#include "OGLWdgt.h"
#include "OGLPP.h"
#include "oclinfo.h"
#include "oglinfo.h"
#include "oglnbody.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    _noclInf noclInf;
    int uiCurPlat;
    int uiCurDev;

protected:
    void changeEvent(QEvent *e);
    void resizeEvent(QResizeEvent * event);

private:
    Ui::MainWindow *ui;
    OGLWdgt *ogl;
    OGLPP *oglpp;
    oglnbody *oglnb;
    oclInfo *oclinfo;
    oglinfo *oglinf;
    QTimer *timer;
    QTimer *timerfr;
    QTimer *timerpp;
    QTimer *timerppfr;
    QTimer *timernb;
    QTimer *timernbfr;

private slots:
    void on_pbNBody_clicked();
    void on_cmbDevice_currentIndexChanged(int index);
    void on_cmbPlatform_currentIndexChanged(int index);
    void on_pbPPStart_clicked();
    void on_hsFreq_valueChanged(int value);
    void on_tabWidget_selected(QString );
    void on_horizontalSlider_valueChanged(int value);
    void on_pushButton_2_clicked();
    void OpenFrmInfo();
    void OpenFrmOGLInfo();
};

#endif // MAINWINDOW_H
