#include "oglinfo.h"
#include "ui_oglinfo.h"

oglinfo::oglinfo(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::oglinfo)
{
    ui->setupUi(this);

    GetInfo();
    this->resize(256,512);

}

oglinfo::~oglinfo()
{
    delete ui;
}

void oglinfo::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void oglinfo::on_pbClose_clicked()
{
    this->close();
}

void oglinfo::GetInfo()
{
    QGLWidget qglw;
    qglw.updateGL();
    QString qsExt(QLatin1String((char *)glGetString(GL_EXTENSIONS)));
    qsExt=qsExt.trimmed().replace("  "," ");
    QStringList qslExt=qsExt.split(" ");

    ui->lblVersion->setText("Version: <b>"+QString((char *)glGetString(GL_VERSION))+"</b>");
    ui->lblVendor->setText("Vendor: <b>"+QString((char *)glGetString(GL_VENDOR))+"</b>");
    ui->lblRenderer->setText("Renderer: <b>"+QString((char *)glGetString(GL_RENDERER))+"</b>");

    for (int i=0;i<qslExt.count();i++)
    {
        QTreeWidgetItem *ptwg=new QTreeWidgetItem(ui->twInfo);
        ptwg->setText(0,qslExt.at(i));
    }
    ui->twInfo->setHeaderLabel("Extensions ("+QString().number(qslExt.count())+")");

}
