#ifndef OGLNBODY_H
#define OGLNBODY_H

#include <QGLWidget>
#include <QMessageBox>
#include "_nglew.h"
#include "_nocl.h"

class oglnbody : public QGLWidget
{
Q_OBJECT
protected:
    virtual void initializeGL();
    virtual void resizeGL(int nWidth,int nHeight);
    virtual void paintGL();
    virtual void mousePressEvent(QMouseEvent *qme);
    virtual void mouseMoveEvent(QMouseEvent *qme);
    virtual void wheelEvent(QWheelEvent * qwe);
public:
    explicit oglnbody(QWidget *parent = 0);

    void GenInit();
    void RunKernel();
    cl_int Cleanup(cl_int iErr);

    float fxRot;
    float fyRot;
    float fzRot;
    float fzTr;
    float fx;

    _glewFun glewFun;
    _noclInf noclInf;
    int uiCurPlat;
    int uiCurDev;

    int nWidth;
    int nHeight;

    int iCountSec;

    QPoint qpoint;

    char cErr[256];
    cl_int iErr;

    bool brun;
    cl_int cliNumPart;
    cl_float *initPos;
    cl_float *initVel;
    cl_float *Pos;
    cl_float *Vel;
    cl_float delT;
    cl_float espSqr;

    cl_context clc;
    cl_program clp;
    cl_kernel clk;
    cl_mem updatedPos;
    cl_mem updatedVel;
    cl_command_queue clcq;

    QLCDNumber *qlsd;
signals:

public slots:
    void draw(float fxx);
    void animate();
    void framecount();

};

#endif // OGLNBODY_H
