#ifndef OGLPP_H
#define OGLPP_H

#include <QGLWidget>
#include <QMessageBox>
#include "_nglew.h"
#include "_nocl.h"

class OGLPP : public QGLWidget
{
Q_OBJECT
protected:
    virtual void initializeGL();
    virtual void resizeGL(int nWidth,int nHeight);
    virtual void paintGL();
    virtual void mousePressEvent(QMouseEvent *qme);
    virtual void mouseMoveEvent(QMouseEvent *qme);
    virtual void wheelEvent(QWheelEvent * qwe);
public:
    explicit OGLPP(QWidget *parent = 0);

    void GenInit();
    void RunKernel();
    cl_int Cleanup(cl_int iErr);

    float fxRot;
    float fyRot;
    float fzRot;
    float fzTr;
    float fx;

    float fanim;

    _glewFun glewFun;
    _noclInf noclInf;
    int uiCurPlat;
    int uiCurDev;

    int nWidth;
    int nHeight;

    QPoint qpoint;

    char cErr[256];
    cl_int iErr;

    bool brun;
    int image_width;
    int image_height;

    int iCountSec;

    cl_context clc;
    cl_program clp;
    cl_kernel clk;
    cl_command_queue clcq;
    cl_mem cl_pbo[2];

    GLuint pbos;
    GLuint pbod;
    GLuint texscreen;
    GLUquadric* quad;

    QLCDNumber *qlsd;
signals:

public slots:
    void draw(float fxx);
    void animate();
    void framecount();

};

#endif // OGLWDGT_H
